/**
	$Id: ParentBioMaterialLoader.java 5664 2011-06-23 09:53:05Z nicklas $

	Copyright (C) 2009 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.plugins;

import net.sf.basedb.core.BioMaterial;
import net.sf.basedb.core.DbControl;
import net.sf.basedb.core.ItemQuery;
import net.sf.basedb.core.MeasuredBioMaterial;

/**	
	This class get data from the parents to a {@link MeasuredBioMaterial}
	@author martin
	@version 2.12
	@base.modified $Date: 2011-06-23 11:53:05 +0200 (Thu, 23 Jun 2011) $
*/

public class ParentBioMaterialLoader 
	extends ItemQueryLoader<MeasuredBioMaterial>
{

	public ParentBioMaterialLoader(ItemQuery<? extends BioMaterial> query, String parameterName)
	{
		super(query, parameterName);
	}
	
	@Override
	public Object getData(ExportedProperty exportedProperty, MeasuredBioMaterial item) 
		throws Exception
	{
		Object parents = null;
		DbControl dc = item.getDbControl();
		if (item.getParentType() == null)
		{
			// No parents
		}
		else if (item.hasSingleParent())
		{
			try
			{
				parents = item.getParent();
			}
			catch(Throwable e)
			{}
		}
		else
		{
			parents = super.getData(exportedProperty, item);
		}
		return parents;
	}

}
