/**
	$Id: UsableDataFileType.java 5713 2011-09-02 13:01:58Z nicklas $

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	Utility interface for collecting information about 
	data file requirements when used on a certain platform/variant
	or item subtype.
	
	@author nicklas
	@since 3.0
	@see PlatformFileType
	@see ItemSubtypeFileType
*/
public interface UsableDataFileType 
{

	/**
		Get the data file type the information applies to.
	*/
	public DataFileType getDataFileType();
	
	/**
		A flag indicating if a file should be required or not.
	*/
	public boolean isRequired();
	
	/**
		A flag indicating if it is allowed to attach multiple files
		or only a single one of the given type.
	*/
	public boolean getAllowMultiple();
	
}
