/*
  $Id: ClientDefaultSettingData.java 5818 2011-10-21 11:15:41Z nicklas $

	Copyright (C) 2005 Johan Enell, Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

  BASE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3
  of the License, or (at your option) any later version.

  BASE is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

/**
	@author nicklas, enell
	@see net.sf.basedb.core.ClientDefaultSetting
	@see <a href="../../../../../../html/developer/api/data_api.clients.html">Developer documentation: Client, session and settings</a>
	@hibernate.class table="`ClienDefaultSettings`" lazy="false"
	@version 2.0
	@base.modified $Date: 2011-10-21 13:15:41 +0200 (Fri, 21 Oct 2011) $
*/
public class ClientDefaultSettingData
	extends SettingData
{

	public ClientDefaultSettingData()
	{}

	private ClientData client;
	/**
		Get the client application this setting is valid for.
		@hibernate.many-to-one update="false" outer-join="false"
		@hibernate.column name="`client_id`" not-null="true" unique-key="uniquesetting"
	*/
	public ClientData getClient()
	{
		return client;
	}
	public void setClient(ClientData client)
	{
		this.client = client;
	}
}
