/**
	$Id: ToTransferable.java 4512 2008-09-11 20:05:50Z jari $

	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.info;

/**
	This interface should be implemented by classes that can
	convert (parts of) it's internal state into a {@link Transferable} 
	object.

	@author nicklas
	@version 2.5
 	@param <T> A kind of object that implements {@link net.sf.basedb.info.ToTransferable} 
	@base.modified $Date: 2008-09-11 22:05:50 +0200 (Thu, 11 Sep 2008) $
*/
public interface ToTransferable<T extends Transferable>
{
	/**
		Transfer the internal state to a transferable object.
		The method should return the same object that is
		passed in as an argument.
	 	@param to The transferable object to use 
	 	@return The transferable object with values set.
	*/
	public T toTransferable(T to);

}
