<%-- $Id:details.jsp 4187 2008-03-20 11:15:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@page import="net.sf.basedb.core.PluginDefinition"%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
 	import="net.sf.basedb.core.ItemNotFoundException"
 	import="net.sf.basedb.util.error.ThrowableUtil"
 	import="net.sf.basedb.util.extensions.ExtensionPoint"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.ActionFactory"
	import="net.sf.basedb.util.extensions.RendererFactory"
	import="net.sf.basedb.util.extensions.AboutBean"
	import="net.sf.basedb.util.extensions.manager.ExtensionsFile"
	import="net.sf.basedb.util.extensions.manager.ExtensionPointKey"
	import="net.sf.basedb.util.extensions.manager.ExtensionKey"
	import="net.sf.basedb.util.extensions.manager.PluginInfoKey"
	import="net.sf.basedb.util.extensions.manager.FactoryParametersKey"
	import="net.sf.basedb.util.extensions.manager.ProcessResults"
	import="net.sf.basedb.util.extensions.manager.ProcessResults.FileResults"
	import="net.sf.basedb.util.extensions.xml.PluginInfo"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.core.plugin.About"
	import="java.util.List"
	import="java.util.Date"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
String displayFactory(ExtensionsFile file, Object factory)
{
	if (factory == null)
	{
		return "<i>- none -</i>";
	}
	String text = factory.getClass().getName();
	String parameters = file == null ? null : file.getMetadata(new FactoryParametersKey(factory));
	if (parameters != null)
	{
		text += "<pre>" + HTML.encodeTags(parameters) + "</pre>";
	}
	return text;
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
String extensionId = request.getParameter("extensionId");
String extensionPointId = request.getParameter("extensionPointId");
String fileuri = request.getParameter("fileuri");

DbControl dc = sc.newDbControl();
try
{
	final ExtensionsControl ec = ExtensionsControl.get(dc);
	final boolean writePermission = ec.hasPermission(Permission.WRITE);
	
	Extension<?> ext = null;
	ExtensionPoint<?> ep = null;
	ExtensionsFile file = null;
	ExtensionsFile extFile = null;
	ExtensionsFile epFile = null;

	if (fileuri != null)
	{
		file = ec.getFile(fileuri);
		if (file == null)
		{
			throw new ItemNotFoundException("ExtensionsFile[uri=" + fileuri + "]");
		}
	}
	
	if (extensionId != null)
	{
		ext = ec.getExtension(extensionId);
		if (ext == null)
		{
			throw new ItemNotFoundException("Extension[id=" + extensionId + "]");
		}
		extensionPointId = ext.getExtends();
		extFile = ec.getFileByObjectKey(new ExtensionKey(extensionId));
	}
	
	if (extensionPointId != null)
	{
		ep = ec.getExtensionPoint(extensionPointId);
		if (ep == null)
		{
			throw new ItemNotFoundException("ExtensionPoint[id=" + extensionPointId + "]");
		}
		epFile = ec.getFileByObjectKey(new ExtensionPointKey(extensionPointId));
	}
%>
<base:page title="" type="popup">
	<base:head scripts="newjoust.js,table.js" styles="newjoust.css,table.css,toolbar.css">
	<script language="JavaScript">

	function enableExtension(enable)
	{
		var iconName = enable ? 'Extension' : 'ExtensionDisabled';
		window.parent.frames['tree'].setIcon('<%=extensionId%>', iconName);
		var url = 'index.jsp?ID=<%=ID%>&cmd=EnableExtension';
		url += '&extensionId=<%=extensionId%>';
		url += '&enable='+enable;
		location.href = url;
	}

	function enableExtensionPoint(enable)
	{
		var iconName = enable ? 'ExtensionPoint' : 'ExtensionPointDisabled';
		window.parent.frames['tree'].setIcon('<%=extensionPointId%>', iconName);
		var url = 'index.jsp?ID=<%=ID%>&cmd=EnableExtensionPoint';
		url += '&extensionPointId=<%=extensionPointId%>';
		url += '&enable='+enable;
		location.href = url;
	}
	
	function enableFile(enable)
	{
		window.parent.frames['tree'].setChildIcons('<%=HTML.javaScriptEncode(file != null ? file.getName() : "")%>', enable);
		var url = 'index.jsp?ID=<%=ID%>&cmd=EnableFile';
		url += '&fileuri=<%=HTML.urlEncode(fileuri)%>';
		url += '&enable='+enable;
		location.href = url;
	}
	
	function showFile(fileuri)
	{
		window.parent.frames['tree'].selectFile(fileuri);
	}

	function editPlugin(pluginId)
	{
		Main.viewOrEditItem('<%=ID%>', 'PLUGINDEFINITION', pluginId, true);
	}
	
	function manualScan()
	{
		Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ManualScan', 'ManualScan', 800, 480);
	}
	
	function scanResults()
	{
		Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ScanResults', 'ScanResults', 600, 480);
	}

	function toggleStacktrace(evt, id)
	{
		Main.showHide('stacktrace.' + id);
	}
	
	</script>
	</base:head>
		<base:body>

		<tbl:toolbar>

		<%
		if (ext != null)
		{
			boolean isEnabled = ec.isEnabled(ext);
			boolean hasRegistrationError = extFile != null && extFile.hasError();
			boolean allow = writePermission && !hasRegistrationError;
			%>
			<tbl:button 
				onclick="<%="enableExtension(" + (isEnabled ? "0" : "1") + ")"%>" 
				title="<%=isEnabled ? "Disable" : "Enable" %>" 
				image="<%=allow ? "joust/extension.png" : "joust/extensiondisabled.png" %>"
				tooltip="Disable this extension"
				disabled="<%=!allow%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'extensions.details.extension')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			<%
		}
		else if (ep != null)
		{
			boolean isEnabled = ec.isEnabled(ep);
			boolean hasRegistrationError = epFile != null && epFile.hasError();
			boolean allow = writePermission && !hasRegistrationError;
			%>
			<tbl:button 
				onclick="<%="enableExtensionPoint(" + (isEnabled ? "0" : "1") + ")"%>" 
				title="<%=isEnabled ? "Disable" : "Enable" %>" 
				image="<%=allow ? "joust/extensionpoint.png" : "joust/extensionpointdisabled.png" %>"
				tooltip="Disable this extension point"
				disabled="<%=!allow%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'extensions.details.extensionspoint')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			<%
		}
		else if (file != null)
		{
			boolean hasRegistrationError = file.hasError();
			boolean allow = writePermission && !hasRegistrationError;
			%>
			<tbl:button 
				onclick="enableFile(1)" 
				title="Enable all" 
				image="<%=allow ? "joust/extension.png" : "joust/extensiondisabled.png" %>"
				tooltip="Enable all extensions in this file"
				disabled="<%=!allow%>"
			/>
			<tbl:button 
				onclick="enableFile(0)" 
				title="Disable all" 
				image="<%=allow ? "joust/extension.png" : "joust/extensiondisabled.png" %>"
				tooltip="Disable all extensions in this file"
				disabled="<%=!allow%>"
			/>
			<%
		}
		else
		{
			%>
			<tbl:button
				onclick="manualScan()"
				title="Install/uninstall&hellip;"
				image="<%=writePermission ? "new_wizard.gif" : "new_wizard_disabled.gif" %>"
				tooltip="Install and uninstall extensions and plug-ins"
				disabled="<%=!writePermission%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'extensions.details.main')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			<%
		}
		%>
		</tbl:toolbar>

		<div class="boxedbottom">
		
		<%
		if (ext != null)
		{
			About about = ext.getAbout();
			if (about == null) about = new AboutBean();
			Throwable error = ec.getLastExtensionError(ext.getId());
			if (error != null)
			{
				%>
					<div class="error">
						<base:icon image="error.gif" 
							onclick="<%="toggleStacktrace(event, '" + ext.getId() + "')"%>" 
							style="float: left;"
							tooltip="Error - click to show full stack trace"
						/><%=error.getMessage() %>
						<div id="stacktrace.<%=ext.getId()%>"
							class="stacktrace"
							style="display: none;"
							><%=ThrowableUtil.stackTraceToString(error)%></div>
					</div>
					<%
			}
			%>
				<table class="form" cellspacing="0">
				<tr>
					<td class="prompt">ID</td>
					<td><%=ext.getId()%></td>
				</tr>
				<tr>
					<td class="prompt">Name</td>
					<td><%=HTML.encodeTags(about.getName())%></td>
				</tr>
				<tr>
					<td class="prompt">File</td>
					<td>
						<a href="javascript:showFile('<%=HTML.javaScriptEncode(extFile.getName())%>')"
						><%=extFile.getName()%></a> 
						(<%=extFile.checkModified() ? "Modified" : "Up to date" %>;
						<%=extFile.hasError() ? "Error" : "Ok" %>)
					</td>
				</tr>
				<tr>
					<td class="prompt">Version</td>
					<td><%=HTML.encodeTags(about.getVersion())%></td>
				</tr>
				<tr>
					<td class="prompt">Description</td>
					<td><%=HTML.niceFormat(about.getDescription())%></td>
				</tr>
				<tr>
					<td class="prompt">Copyright</td>
					<td><%=HTML.encodeTags(about.getCopyright())%></td>
				</tr>
				<tr>
					<td class="prompt">Contact</td>
					<td><%=HTML.encodeTags(about.getContact())%></td>
				</tr>
				<tr>
					<td class="prompt">Email</td>
					<td><%=HTML.scanForLinks(about.getEmail(), HTML.LINK_EMAIL, "_new")%></td>
				</tr>
				<tr>
					<td class="prompt">Url</td>
					<td><%=HTML.scanForLinks(about.getUrl(), HTML.LINK_URL, "_new")%></td>
				</tr>
				</tr>
					<tr>
					<td class="prompt">Action factory</td>
					<td><%=displayFactory(extFile, ext.getActionFactory())%></td>
				</tr>
				</tr>
				<tr>
					<td class="prompt">Renderer factory</td>
					<td><%=displayFactory(extFile, ext.getRendererFactory())%></td>
				</tr>
				</table>
			<%
		}
		%>
		<%
		if (ep != null)
		{
			if (ext != null)
			{
				%>
				<h4>Extension point</h4>
				<%
			}
			Throwable error = ec.getLastExtensionPointError(ep.getId());
			if (error != null)
			{
				%>
					<div class="error">
						<base:icon image="error.gif" 
							onclick="<%="toggleStacktrace(event, '" + ep.getId() + "')"%>" 
							style="float: left;"
							tooltip="Error - click to show full stack trace"
						/><%=error.getMessage() %>
						<div id="stacktrace.<%=ep.getId()%>"
							class="stacktrace"
							style="display: none;"
							><%=ThrowableUtil.stackTraceToString(error)%></div>
					</div>
					<%
			}
			%>
			<table class="form" cellspacing="0">
			<tr>
				<td class="prompt">ID</td>
				<td><%=ep.getId()%></td>
			</tr>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(ep.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">File</td>
				<td>
					<%
					if (epFile != null)
					{
						%>
						<a href="javascript:showFile('<%=HTML.javaScriptEncode(epFile.getName())%>')"
						><%=epFile.getName()%></a> 
						(<%=epFile.checkModified() ? "Modified" : "Up to date" %>;
						<%=epFile.hasError() ? "Error" : "Ok" %>)
						<%
					}
					%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(ep.getDescription())%></td>
			</tr>
			<tr>
				<td class="prompt">Action class</td>
				<td><%=ep.getActionClass().getName()%></td>
			</tr>
			<tr>
				<td class="prompt">Renderer factory</td>
				<td><%=displayFactory(epFile, ep.getRendererFactory())%></td>
			</tr>
			<tr>
				<td class="prompt">Error handler factory</td>
				<td><%=displayFactory(epFile, ep.getErrorHandlerFactory() == null ? 
						ec.getDefaultErrorHandlerFactory() : ep.getErrorHandlerFactory())%></td>
			</tr>
			</table>
			<%
		}
		%>
			
		<%
		if (file != null)
		{
			About about = file.getAbout();
			if (about == null) about = new AboutBean();
			%>
			<table class="form" cellspacing="0">
			<tr>
				<td class="prompt">File</td>
				<td><%=file.getName()%></td>
			</tr>
			<tr>
				<td class="prompt">Type</td>
				<td><%=file.isJar() ? "JAR file" : "XML file"%></td>
			</tr>
			<tr>
				<td class="prompt">Up to date</td>
				<td><%=file.checkModified() ? "No" : "Yes"%></td>
			</tr>
			<tr>
				<td class="prompt">Errors</td>
				<td>
					<%
					if (file.hasError())
					{
						ProcessResults results = ec.getLastScanResults();
						FileResults fileResults = results.getResults(file);
						List<String> messages = fileResults.getMessages();
						Throwable validationError = file.getValidationError();
						%>
						<ul style="padding-left: 20px; margin: 0px; text-align: left;" class="error">
						<%
						if (validationError != null)
						{
							%>
							<li><%=validationError.getClass().getSimpleName()%>: <%=HTML.niceFormat(validationError.getMessage())%>
							<%
						}
						for (String msg : messages)
						{
							%>
							<li><%=HTML.niceFormat(msg)%>
							<%
						}
						%>
						</ul>
						<%
					}
					else
					{
						%>
						No
						<%
					}
					%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(about.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Version</td>
				<td><%=HTML.encodeTags(about.getVersion())%></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(about.getDescription())%></td>
			</tr>
			<tr>
				<td class="prompt">Copyright</td>
				<td><%=HTML.encodeTags(about.getCopyright())%></td>
			</tr>
			<tr>
				<td class="prompt">Contact</td>
				<td><%=HTML.encodeTags(about.getContact())%></td>
			</tr>
			<tr>
				<td class="prompt">Email</td>
				<td><%=HTML.scanForLinks(about.getEmail(), HTML.LINK_EMAIL, "_new")%></td>
			</tr>
			<tr>
				<td class="prompt">Url</td>
				<td><%=HTML.scanForLinks(about.getUrl(), HTML.LINK_URL, "_new")%></td>
			</tr>
			</table>
			<%
		}
		%>
		<%
		if (ext == null && ep == null && file == null)
		{
			ProcessResults results = ec.getLastScanResults();
			Formatter dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
			%>
			<table class="form" cellspacing="0">
			<tr>
				<td class="prompt">Last installation</td>
				<td><%=results.hasError() ? "Failed": "Successful" %></td>
			</tr>
			<tr>
				<td class="prompt" style="text-align: right; font-weight: normal;">- ended</td>
				<td><%=dateTimeFormatter.format(new Date(results.getEndTime())) %></td>
			</tr>
			<tr>
				<td class="prompt" style="text-align: right; font-weight: normal;">- summary</td>
				<td>
				<%=HTML.niceFormat(results.getSummary())%></td>
			</tr>
			<tr>
				<td  class="prompt" style="text-align: right; font-weight: normal;"><base:icon image="bullet.gif" /></td>
				<td>
					<a href="javascript:scanResults()" 
						title="Display detailed information about the last scan"
						>More details&hellip;</a>
				</td>
			</tr>
			</table>
			<%
		}
		%>
		</div>
		</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
