<%-- $Id: edit_list.jsp 5812 2011-10-17 14:19:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BioMaterialList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.BIOMATERIALLIST;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	BioMaterialList list = null;
	Item memberType = null;
	boolean addBioMaterials = false;
	boolean mergeLists = false;
	int numSelectedLists = cc.getSelected().size();
	String formId = request.getParameter("formId");
	String fromContext = Values.getStringOrNull(request.getParameter("fromContext"));
	String subContext = request.getParameter("subContext");

	if (itemId == 0)
	{
		title = "Create biomaterial list";
		cc.removeObject("item");
		addBioMaterials = Values.getBoolean(request.getParameter("addBioMaterials"));
		if (numSelectedLists > 0)
		{
			for (int selectedId : cc.getSelected())
			{
				BioMaterialList selectedList = BioMaterialList.getById(dc, selectedId);
				if (memberType == null)
				{
					memberType = selectedList.getMemberType();
				}
				else if (memberType != selectedList.getMemberType())
				{
					numSelectedLists = 0;
					memberType = null;
					break;
				}
			}
		}
		if (memberType == null)
		{
			memberType = fromContext != null ? Item.valueOf(fromContext) : Item.fromValue(Values.getInt(cc.getPropertyValue("memberType")));
		}
		mergeLists = numSelectedLists > 0;
	}
	else
	{
		list = BioMaterialList.getById(dc, itemId);
		memberType = list.getMemberType();
		cc.setObject("item", list);
		title = "Edit biomaterial list -- " + HTML.encodeTags(list.getName());
		list.checkPermission(Permission.WRITE);
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), list);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Biomaterial list" tab
		function validateList()
		{
			var frm = document.forms['list'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['list'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (frm.source) Forms.createHidden(frm, 'items', getSelectedItems().join(','));
				frm.memberType.disabled = false;
				frm.submit();
			}
		}
		
		function init()
		{
			var frm = document.forms['list'];
			<%
			if (list == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			if (frm.source)
			{
				if (getSelectedItems().length == 0)
				{
					frm.source[0].disabled = true;
					var lblSelected = document.getElementById('lblSelected');
					//aSelected.href = 'javascript:void(0)';
					lblSelected.disabled = true;
					Main.addClass(lblSelected, 'disabled');
				}
				else
				{
					Forms.checkRadio(frm.source, 'selected');
				}
			}
		}
		function checkRadio(radio, name)
		{
			Forms.checkRadio(radio, name);
		}

		// Get the ID:s of all selected items
		var selectedItems = new Array();
		var hasCheckSelectedItems = false;
		function getSelectedItems()
		{
			<%
			if (formId != null)
			{
				%>
				if (!hasCheckSelectedItems)
				{
					selectedItems = window.opener.Table.getSelected('<%=formId%>');
					hasCheckedSelectedItems = true;
				}
				<%
			}
			%>
			return selectedItems;
		}
		
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="list" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="fromContext" value="<%=fromContext%>">
		<%
		if (subContext != null)
		{
			%>
			<input type="hidden" name="subContext" value="<%=subContext%>">
			<%
		}
		%>
		<h3 class="docked"><%=title%> <base:help tabcontrol="settings"/></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom"  remember="<%=list != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Biomaterial list" validate="validateList()" helpid="biomateriallist.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(list == null ? Values.getString(cc.getPropertyValue("name"), "New list") : list.getName())%>" 
					size="40" maxlength="<%=BioMaterialList.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Member type</td>
				<td>
					<select name="memberType" <%=mergeLists || list != null ? "disabled" : "" %>>
						<option value="BIOSOURCE" <%=memberType == Item.BIOSOURCE ? "selected" : ""%>>Biosource
						<option value="SAMPLE" <%=memberType == Item.SAMPLE ? "selected" : ""%>>Sample
						<option value="EXTRACT" <%=memberType == Item.EXTRACT ? "selected" : ""%>>Extract
					</select>
				</td>
			</tr>
			<%
			if (addBioMaterials)
			{
				%>
				<tr valign="top">
					<td class="prompt">Source biomaterials</td>
					<td>
						<input type="radio" name="source" id="sourceSelected" value="selected"
							><label for="sourceSelected" id="lblSelected">Selected items</label><br>
						<input type="radio" name="source" id="sourcePage" value="page"
							><label for="sourcePage">Current page</label><br>
						<input type="radio" name="source" id="sourceAll" value="all" checked
							><label for="sourceAll">All pages</label><br>
					</td>
				</tr>
				<tr>
					<td class="prompt">Include pooled</td>
					<td>
						<input type="checkbox" name="pooled" id="pooled" value="1"
							><label for="pooled">Include pooled children/parents in the list</label><br>
					</td>
				</tr>
				<%
			}
			else if (mergeLists)
			{
				%>
				<tr valign="top">
					<td class="prompt">Add members?</td>
					<td>
						<input type="radio" name="create" id="createEmpty" value=""
							><label for="createEmpty" title="The new list will be empty">No</label><br>
						<input type="radio" name="create" id="createUnion" value="union" checked
							><label for="createUnion" title="The new list contains all items from the selected lists">Union of selected lists</label> <base:icon image="set_operations/union_small.png" /><br>
						<input type="radio" name="create" id="createIntersection" value="intersection"
							><label for="createIntersection" title="The new list contains only items that are present in ALL selected lists">Intersection of selected lists</label> <base:icon image="set_operations/intersection_small.png" /><br>
						<input type="radio" name="create" id="createCount" value="count"
							><label for="createCount" title="The new list contains only items that are present in some of selected lists">Present in at least</label>
							<input type="text" class="text" name="minCount" size="2" maxlength="2"
								value="1"
								onkeypress="return Numbers.integerOnly(event)"
								onfocus="checkRadio(document.forms['list'].create, 'count');">
							of the selected lists (1-<%=numSelectedLists%>).
							<br>
						
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<td class="prompt">External ID</td>
				<td><input <%=clazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(list == null ? Values.getString(cc.getPropertyValue("externalId"), "") : list.getExternalId())%>" 
					size="40" maxlength="<%=BioMaterialList.MAX_EXTERNAL_ID_LENGTH%>"></td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(list == null ? cc.getPropertyValue("description") : list.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'list', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
