<%-- $Id: merge.jsp 5451 2010-10-26 12:55:47Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BioMaterialList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.BIOMATERIALLIST;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String mergeType = request.getParameter("mergeType");
	BioMaterialList bmList = BioMaterialList.getById(dc, itemId);
	cc.setObject("item", bmList);
	String title = "Add/keep/remove items: " + HTML.encodeTags(bmList.getName());
	bmList.checkPermission(Permission.WRITE);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="linkitems.js">
		<script language="JavaScript">
		// Validate the "Biomaterial list" tab
		function validateForm()
		{
			var frm = document.forms['merge'];
			if (frm.bioMaterialLists.length == 0)
			{
				alert("You must select at least one other biomaterial list");
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['merge'];
			if (validateForm())
			{
				frm.sourceLists.value = Link.getActionIds(1, 'B').join(',');
				frm.submit();
			}
		}
		
		function addBioMaterialListsOnClick()
		{
			var frm = document.forms['merge'];
			var ids = Link.getListIds(frm.bioMaterialLists, 'B');
			ids[ids.length] = <%=itemId%>;
			var excludes = ids.join(',');
			var url = 'index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addBioMaterialListsCallback';
			url += "&exclude="+excludes;
			url += '&resetTemporary=1&tmpfilter:INT:memberType=<%=bmList.getMemberType().getValue()%>';
			Main.openPopup(url, 'AddBioMaterialLists', 1000, 700);
		}
		function addBioMaterialListsCallback(bioMaterialListId, name)
		{
			var item = Link.getItem('B', bioMaterialListId);
			if (!item) item = new Item('B', bioMaterialListId, name);
			Link.addItem(document.forms['merge'].bioMaterialLists, item);
		}
		function removeBioMaterialListsOnClick()
		{
			Link.removeSelected(document.forms['merge'].bioMaterialLists);
		}
		
		function updateImage()
		{
			var frm = document.forms['merge'];
			var img = document.getElementById('mergeImage');
			var mergeType = frm.mergeType[frm.mergeType.selectedIndex].value;
			var sourceMerge = frm.sourceMerge[frm.sourceMerge.selectedIndex].value;
			var url = '../../images/set_operations/'+mergeType+'_'+sourceMerge+'.png';
			img.src = url;
		}
		function mergeTypeOnChange()
		{
			updateImage();
		}
		function sourceMergeOnChange()
		{
			updateImage();
		}
		function init()
		{
			updateImage();
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="merge" onsubmit="return false;">
		<input type="hidden" name="cmd" value="MergeItem">

		<h3 class="docked"><%=title%> <base:help helpid="biomateriallist.merge" /></h3>
		<div class="boxedbottom" style="height: <%=(int)(scale*300)%>px; ">
			<table class="form" cellspacing=0>

			<tr>
				<td class="prompt">This list</td>
				<td><%=HTML.encodeTags(bmList.getName())%></td>
				<td rowspan="2">
					<img id="mergeImage" src="../../images/set_operations/union_union.png">
				</td>
			</tr>
			<tr>
				<td class="prompt">What to do</td>
				<td>
					<select name="mergeType" onchange="mergeTypeOnChange()">
						<option value="union" <%="union".equals(mergeType) ? "selected" : ""%>
							>Add items to
						<option value="intersection" <%="intersection".equals(mergeType) ? "selected" : ""%>
							>Keep items in
						<option value="complement" <%="complement".equals(mergeType) ? "selected" : ""%>
							>Remove items from
					</select><br>
					this list that are present in
					<br>
					<select name="sourceMerge" onchange="sourceMergeOnChange()">
						<option value="union" <%="intersection".equals(mergeType) ? "" : "selected"%>
							>some of
						<option value="intersection" <%="intersection".equals(mergeType) ? "selected" : ""%>
							>all of
					</select><br>
					the biomaterial lists selected below.
					<p>
					After the operation this list will
					contain items from the red-colored areas in the image.
					 
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Biomaterial lists</td>
				<td colspan="2">
					<table border="0" cellspacing="0" cellpadding="0">
					<tr valign="top">
					<td>
						<select name="bioMaterialLists" size="5" multiple style="width: 20em;">
						</select>
						<input type="hidden" name="sourceLists" value="">
					</td>
					<td>
						<table border="0">
						<tr><td width="150"><base:button 
							onclick="addBioMaterialListsOnClick()" 
							title="Add&nbsp;biomaterial lists&hellip;" 
							tooltip="Add biomaterial lists"
							/></td></tr>
						<tr><td width="150"><base:button 
							onclick="removeBioMaterialListsOnClick()" 
							title="Remove" 
							tooltip="Remove the selected lists"
						/></td></tr>
						</table>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			</table>
		
		</div>
		
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Ok" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
