<%-- $Id: edit_multiple_file.jsp 5812 2011-10-17 14:19:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Config"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileServer"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.nio.charset.Charset"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.FILE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	if (cc.getSelected().size() == 0)
	{
		throw new PermissionDeniedException("No files have been selected");
	}
	String title = "Edit " + cc.getSelected().size() + " files";

	// Query to retrieve file types
	final ItemQuery<ItemSubtype> fileTypeQuery = ItemSubtype.getQuery(itemType);
	fileTypeQuery.order(Orders.asc(Hql.property("name")));
	fileTypeQuery.setCacheResult(true);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "File" tab
		function validateFile()
		{
			var frm = document.forms['file'];

			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['file'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function keepMimeTypeOnClick()
		{
			var frm = document.forms['file'];
			frm.mimeType.disabled = frm.keepMimeType.checked;
			if (!frm.mimeType.disabled) frm.mimeType.focus();
		}
		
		function mimeTypeOnClick()
		{
			var frm = document.forms['file'];
			var url = '../../admin/mimetypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setMimeTypeCallback';
			Main.openPopup(url, 'SelectMimeType', 1000, 700);
		}
		function setMimeTypeCallback(id, name)
		{
			var frm = document.forms['file'];
			frm.mimeType.value = name;
			frm.mimeType.disabled = false;
			frm.keepMimeType.checked = false;
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="file" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateMultipleItems">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*300)+"px;"%>" 
			position="bottom">
		<t:tab id="info" title="Properties" validate="validateFile()" helpid="file.edit">
			<table class="form" cellspacing=0>

			<tr>
				<td class="prompt">Write protected</td>
				<td>
					<input type="radio" name="write_protected" id="writeProtectedKeep" value="keep" checked><label for="writeProtectedKeep">No change</label>
					<input type="radio" name="write_protected" id="writeProtectedNo" value="0"><label for="writeProtectedNo">No</label>
					<input type="radio" name="write_protected" id="writeProtectedYes" value="1"><label for="writeProtectedYes">Yes</label></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Type</td>
				<td colspan="2">
					<select name="filetype_id">
					<option value="keep" selected>- no change -
					<option value="0">- none -
					<%
					ItemResultList<ItemSubtype> fileTypes = fileTypeQuery.list(dc);
					for (ItemSubtype fileType : fileTypes)
					{
						int id = fileType.getId();
						%>
						<option value="<%=id%>"><%=HTML.encodeTags(fileType.getName())%>
						<%
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">MIME type</td>
				<td>
					<input type="checkbox" name="keepMimeType" id="keepMimeType" value="1" checked 
						onclick="keepMimeTypeOnClick()"><label for="keepMimeType">No change</label><br>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td><input <%=clazz%> type="text" name="mimeType" disabled
							value="" size="40" maxlength="<%=File.MAX_MIMETYPE_LENGTH%>">&nbsp;</td>
						<td><base:button onclick="mimeTypeOnClick()" title="Select&hellip;"/></td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="prompt">Character set</td>
				<td>
					<select name="characterSet">
					<option value="keep">- no change -
					<option value="">- n/a -
					<%
					int numCommon = Config.getCommonCharsets().size();
					int i = 0;
					for (String charset : Config.getAllCharsets())
					{
						%>
						<option value="<%=charset%>" <%=i==numCommon ? "style=\"border-top: 1px solid #666666;\"" : "" %>><%=charset%>
						<%
						i++;
					}
					%>
					</select>
				</td>
			</tr>
			</table>
		</t:tab>

		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
