<%-- $Id: select_file.jsp 5713 2011-09-02 13:01:58Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.*"
	import="net.sf.basedb.clients.web.*"
%>
<%@ taglib
	prefix="base" uri="/WEB-INF/base.tld"
%>
<%
SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, Item.FILE);
String ID = sc.getId();
String requestTitle = request.getParameter("title");
String callback = request.getParameter("callback");
final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String title = mode.generateTitle("file", "files");
%>
<base:page title="<%=requestTitle == null ? title : requestTitle%>" type="popup">
<base:head >
	<script language="JavaScript">
	var timer = 0;
	var inCall = false;
	function adjustIFrameSize()
	{
		if (inCall) return;
		inCall = true;
		var iframeElement = document.getElementById("idManager");
		// Find the top coordinate of the IFrame
		var offsetTop = 1;
		var offsetTrail = iframeElement;
		while (offsetTrail)
		{
			offsetTop += offsetTrail.offsetTop;
			offsetTrail = offsetTrail.offsetParent;
		}

		// Find the browser window height
		var windowHeight = Main.getWindowHeight();
		var controlsPos = Main.getElementPosition(document.getElementById('controls'));
		iframeElement.height = windowHeight-offsetTop - controlsPos.height - 15;

		// Adjust the height of the frames
		var iframe = window.frames['manager'];
		var directories = iframe.frames['directories'].document.getElementById('main');
		if (directories) directories.style.height = (iframeElement.height-1)+'px';
		var joust = iframe.frames['directories'].document.getElementById('joust');
		if (joust) joust.style.height = (iframeElement.height-1-30)+'px';
		var files = iframe.frames['files'].document.getElementById('main');
		if (files) files.style.height = iframeElement.height+'px';
		inCall = false;
	}
	function setTimer()
	{
		if (inCall) return;
		if (timer) clearTimeout(timer);
		timer = setTimeout('adjustIFrameSize()', 150);
	}
	function setSelected(fileId, path)
	{
		var frm = document.forms['file'];
		frm.file_id.value = fileId;
		frm.path.value = path;
	}
	function addSelected(fileId, path)
	{
		var frm = document.forms['file'];
		if (getSelectedFileIndex(fileId) == -1)
		{
			frm.paths[frm.paths.length] = new Option(path, fileId);
		}
	}
	function removeSelected(fileId)
	{
		var frm = document.forms['file'];
		var index = getSelectedFileIndex(fileId);
		if (index >= 0) frm.paths[index] = null;
	}
	
	function getSelectedFileIndex(fileId)
	{
		var frm = document.forms['file'];
		for (var i = 0; i < frm.paths.length; i++)
		{
			if (frm.paths[i].value == fileId) return i;
		}
		return -1;
	}
	
	function returnSelected()
	{
		var frm = document.forms['file'];
		<%
		if (mode == ModeInfo.SELECTONE)
		{
			%>
			if (frm.file_id.value)
			{
				window.opener.<%=callback%>(frm.file_id.value, frm.path.value);
			}
			<%
		}
		else
		{
			%>
			for (var i = 0; i < frm.paths.length; i++)
			{
				window.opener.<%=callback%>(frm.paths[i].value, frm.paths[i].text);
			}
			<%
		}
		%>		
		window.close();
	}
	</script>
</base:head>
<base:body attributes="onresize='setTimer();'">
	<h3><%=requestTitle == null ? title : requestTitle%></h3>
	<iframe name="manager" id="idManager" src="frameset.jsp?ID=<%=ID%>&mode=<%=mode.getName()%>" width="100%" 
		frameborder="0" vspace="0" hspace="0"
		marginwidth="0" marginheight="0" scrolling="no" style="overflow: visible"></iframe>

	<div style="border-top: 1px solid #666666" id="controls">
	<form name="file">
	<input type="hidden" name="file_id" value="">
	<table class="form" align="center">
	<%
	if (mode == ModeInfo.SELECTONE)
	{
		%>
		<tr>
			<td class="prompt">Selected file</td>
			<td><input type="text" class="text" name="path" size="100" value=""></td>
		</tr>
		<%
	}
	else
	{
		%>
		<tr>
			<td class="prompt">Selected files</td>
			<td><select name="paths" size="5" multiple style="width: 50em;"></select></td>
		</tr>
		<%
	}
	%>
	</table>
	</form>
	
	<table align="center">
	<tr>
		<td width="50%"><base:button onclick="returnSelected();" title="Ok"  /></td>
		<td width="50%"><base:button onclick="window.top.close();" title="Cancel" /></td>
	</tr>
	</table>
	</div>
</base:body>
</base:page>
