<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.DerivedBioAssay"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ListUtil"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.List"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.DERIVEDBIOASSAY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String tabId = Values.getString(request.getParameter("tab"), null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	DerivedBioAssay bioAssay = null;
	String title = null;
	
	boolean readCurrentSubtype = true;
	ItemSubtype currentSubtype = null;

	boolean readCurrentPhysicalBioAssay = true;
	PhysicalBioAssay currentPhysicalBioAssay = null;
	
	boolean readCurrentParentBioAssay = true;
	DerivedBioAssay currentParentBioAssay = null;
	
	boolean readCurrentExtract = true;
	Extract currentExtract = null;

	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;
	
	boolean readCurrentHardware = true;
	Hardware currentHardware = null;
	
	boolean readCurrentSoftware = true;
	Software currentSoftware = null;

	if (itemId == 0)
	{
		title = "New derived bioassay";
		cc.removeObject("item");
		int currentSubtypeId = Values.getInt(request.getParameter("subtype_id"));
		List<ItemSubtype> relatedToParent = Collections.emptyList();
		int parentId = Values.getInt(request.getParameter("parent_id"));
		if (parentId != 0)
		{
			currentParentBioAssay = DerivedBioAssay.getById(dc, parentId);
			if (currentSubtypeId == 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, currentParentBioAssay, Item.DERIVEDBIOASSAY);
			}
			try
			{
				currentPhysicalBioAssay = currentParentBioAssay.getPhysicalBioAssay();
			}
			catch (PermissionDeniedException ex)
			{
				readCurrentPhysicalBioAssay = false;
			}
			try
			{
				currentExtract = currentParentBioAssay.getExtract();
			}
			catch (PermissionDeniedException ex)
			{}
		}
		else
		{
			int physicalBioAssayId = Values.getInt(request.getParameter("physicalbioassay_id"));
			if (physicalBioAssayId != 0)
			{
				currentPhysicalBioAssay = PhysicalBioAssay.getById(dc, physicalBioAssayId);
				if (currentSubtypeId == 0)
				{
					relatedToParent = ItemSubtype.getParentSubtypes(dc, currentPhysicalBioAssay, Item.DERIVEDBIOASSAY);
				}
			}
		}
		if (currentSubtypeId == 0) 
		{
			if (relatedToParent.size() > 0)
			{
				// Find most recently used related subtype
				List<ItemSubtype> recentSubtypes = (List<ItemSubtype>)cc.getRecent(dc, Item.ITEMSUBTYPE);
				currentSubtype = ListUtil.findFirstCommon(recentSubtypes, relatedToParent, relatedToParent.get(0));
			}
			else
			{
				int recentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0));
				currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), recentSubtypeId);
				if (currentSubtypeId > 0) currentSubtype = ItemSubtype.getById(dc, currentSubtypeId);
			}
		}
	}
	else
	{
		bioAssay = DerivedBioAssay.getById(dc, itemId);
		bioAssay.checkPermission(Permission.WRITE);
		cc.setObject("item", bioAssay);
		title = "Edit bioassay -- " + HTML.encodeTags(bioAssay.getName());
		
		try
		{
			currentSubtype = bioAssay.getItemSubtype();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}
		try
		{
			currentParentBioAssay = bioAssay.getParent();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentParentBioAssay = false;
		}
		try
		{
			currentPhysicalBioAssay = bioAssay.getPhysicalBioAssay();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentPhysicalBioAssay = false;
		}
		try
		{
			currentExtract = bioAssay.getExtract();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentExtract = false;
		}
		try
		{
			currentProtocol = bioAssay.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
		try
		{
			currentHardware = bioAssay.getHardware();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentHardware = false;
		}
		try
		{
			currentSoftware = bioAssay.getSoftware();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSoftware = false;
		}
	}

	// Default items 
	int activeProjectId = sc.getActiveProjectId();
	List<Protocol> defaultProtocols = null;
	List<Hardware> defaultHardware = null;
	List<Software> defaultSoftware = null;
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		defaultProtocols = (List<Protocol>)activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.PROTOCOL);
		defaultHardware = (List<Hardware>)activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.HARDWARE);
		defaultSoftware = (List<Software>)activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.SOFTWARE);
	}

	// Load recently used items
	List<PhysicalBioAssay> recentPhysicalBioAssays = (List<PhysicalBioAssay>)cc.getRecent(dc, Item.PHYSICALBIOASSAY);
	List<DerivedBioAssay> recentParentBioAssays = (List<DerivedBioAssay>)cc.getRecent(dc, Item.DERIVEDBIOASSAY);
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL, currentSubtype);
	List<Hardware> recentHardware = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE, currentSubtype);
	List<Software> recentSoftware = (List<Software>)cc.getRecent(dc, Item.SOFTWARE, currentSubtype);
	
	// Query to retrieve item types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), bioAssay);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js,platforms.js,subtypes.js,ajax.js,json2.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "BioAssay" tab
		function validateBioAssay()
		{
			var frm = document.forms['bioAssay'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.isRoot)
			{
				if (frm.isRoot[0].checked)
				{
					if (frm.physicalbioassay_id.selectedIndex < 0)
					{
						alert("You must select a parent bioassay");
						frm.physicalbioassay_id.focus();
						return false;
					}
				}
				else
				{
					if (frm.parent_id.selectedIndex < 0)
					{
						alert("You must select a parent bioassay");
						frm.parent_id.focus();
						return false;
					}
				}
				
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['bioAssay'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				if (dataFilesLoaded)
				{
					frames.datafiles.writeFileActionsToForm(frm);
				}
				if (frm.isRoot)
				{
					if (frm.isRoot[0].checked)
					{
						frm.parent_id.selectedIndex = -1;	
					}
					else
					{
						frm.physicalbioassay_id.selectedIndex = -1;
					}
				}
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		var protocolChanged = false;
		var subtypeChanged = false;
		var dataFilesLoaded = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && (protocolChanged || !annotationsLoaded))
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getProtocolId());
					annotationsLoaded = true;
					protocolChanged = false;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
				else if (tabId == 'datafiles' && (subtypeChanged || !dataFilesLoaded))
				{
					var subtypeId = ItemSubtype.getSubtypeId('bioAssay');
					Platforms.loadDataFilesFrame(frames.datafiles, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, 0, 0, subtypeId);
					dataFilesLoaded = true;
					subtypeChanged = false;
				}
			}
		}
		
		function getProtocolId()
		{
			var frm = document.forms['bioAssay'];
			var protocolId = 0;
			if (frm.protocol_id.length > 0 && !frm.protocol_id.disabled) 
			{
				protocolId = Math.abs(parseInt(frm.protocol_id[frm.protocol_id.selectedIndex].value));				
			}
			return protocolId;
		}
		
		function getParents()
		{
			var frm = document.forms['bioAssay'];
			if (!frm.physicalbioassay_id) return;
			
			var parents = new Array();
			if (frm.isRoot[0].checked)
			{
				var bioAssayId = Math.abs(parseInt(frm.physicalbioassay_id[frm.physicalbioassay_id.selectedIndex].value));
				if (bioAssayId > 0) parents[parents.length] = 'PHYSICALBIOASSAY:'+bioAssayId;
			}
			else
			{
				var bioAssayId = Math.abs(parseInt(frm.parent_id[frm.parent_id.selectedIndex].value));
				if (bioAssayId > 0) parents[parents.length] = 'DERIVEDBIOASSAY:'+bioAssayId;
			}
			return parents;
		}
		
		function subtypeOnChange()
		{
			var frm = document.forms['bioAssay'];
			var subtypeId = ItemSubtype.getSubtypeId('bioAssay');
			subtypeChanged = true;
			var recentInfo = ItemSubtype.getRecentAndRelatedInfo(subtypeId, 'BIOASSAY', ['PROTOCOL', 'HARDWARE', 'SOFTWARE']);
			protocolChanged = ItemSubtype.updateSelectionList(frm.protocol_id, recentInfo.PROTOCOL['recent'], recentInfo.PROTOCOL['default']);
			ItemSubtype.updateSelectionList(frm.hardware_id, recentInfo.HARDWARE['recent'], recentInfo.HARDWARE['default']);
			ItemSubtype.updateSelectionList(frm.software_id, recentInfo.SOFTWARE['recent'], recentInfo.SOFTWARE['default']);
		}

		
		function selectProtocolOnClick()
		{
			var frm = document.forms['bioAssay'];
			var url = '../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setProtocolCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioAssay', 'PROTOCOL');
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectProtocol', 1000, 700);
		}
		function setProtocolCallback(id, name)
		{
			var frm = document.forms['bioAssay'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			protocolChanged = true;
		}
		function protocolOnChange()
		{
			protocolChanged = true;
		}
		
		function selectPhysicalBioAssayOnClick()
		{
			var frm = document.forms['bioAssay'];
			var url = '../physicalbioassays/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setPhysicalBioAssayCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioAssay', 'PHYSICALBIOASSAY');
			if (frm.physicalbioassay_id.selectedIndex >= 0) 
			{
				var id = Math.abs(parseInt(frm.physicalbioassay_id[frm.physicalbioassay_id.selectedIndex].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectPhysicalBioAssay', 1000, 700);
		}
		function setPhysicalBioAssayCallback(id, name)
		{
			var frm = document.forms['bioAssay'];
			var list = frm.physicalbioassay_id;
			if (list.length < 1 || list[0].value == '0') // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = id;
			list[0].text = name;
			list.selectedIndex = 0;
			physicalBioAssayOnChange();
		}
		function physicalBioAssayOnChange()
		{
			parentsChanged = true;
			initExtracts();
		}
		
		function selectParentBioAssayOnClick()
		{
			var frm = document.forms['bioAssay'];
			var url = 'index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setParentBioAssayCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioAssay', 'DERIVEDBIOASSAY');
			if (frm.parent_id.selectedIndex >= 0) 
			{
				var id = Math.abs(parseInt(frm.parent_id[frm.parent_id.selectedIndex].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectParentBioAssay', 1000, 700);
		}
		function setParentBioAssayCallback(id, name)
		{
			var frm = document.forms['bioAssay'];
			var list = frm.parent_id;
			if (list.length < 1 || list[0].value == '0') // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = id;
			list[0].text = name;
			list.selectedIndex = 0;
			parentBioAssayOnChange();
		}
		function parentBioAssayOnChange()
		{
			parentsChanged = true;
			initExtracts();
		}
		
		function selectHardwareOnClick()
		{
			var frm = document.forms['bioAssay'];
			var url = '../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setHardwareCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioAssay', 'HARDWARE');
			if (frm.hardware_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.hardware_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectHardware', 1000, 700);
		}
		function setHardwareCallback(id, name)
		{
			var frm = document.forms['bioAssay'];
			var list = frm.hardware_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		function selectSoftwareOnClick()
		{
			var frm = document.forms['bioAssay'];
			var url = '../../admin/software/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setSoftwareCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioAssay', 'SOFTWARE');
			if (frm.software_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.software_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectSoftware', 1000, 700);
		}
		function setSoftwareCallback(id, name)
		{
			var frm = document.forms['bioAssay'];
			var list = frm.software_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}

		function init()
		{
			var frm = document.forms['bioAssay'];
			<%
			if (bioAssay == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			if (frm.isRoot) 
			{
				isRootOnChange();
			}
			else
			{
				initExtracts();
			}
		}
		
		function isRootOnChange()
		{
			var frm = document.forms['bioAssay'];
			var isRoot = frm.isRoot[0].checked;
			Main.showHide('physicalBioAssaySection', isRoot);
			Main.showHide('parentBioAssaySection', !isRoot);
			initExtracts();
		}
		
		function initExtracts()
		{
			var frm = document.forms['bioAssay'];
			var extracts = null;
			<%
			if (bioAssay == null)
			{
				%>
				if (frm.isRoot[0].checked)
				{
					if (frm.physicalbioassay_id.selectedIndex >= 0)
					{
						extracts = getExtractsFromPhysicalBioAssay(frm.physicalbioassay_id[frm.physicalbioassay_id.selectedIndex].value);
					}
				}
				else
				{
					if (frm.parent_id.selectedIndex >= 0)
					{
						extracts = getExtractsFromParentBioassay(frm.parent_id[frm.parent_id.selectedIndex].value);
					}
				}
				<%
			}
			else
			{
				if (currentParentBioAssay != null)
				{
					%>
					extracts = getExtractsFromParentBioassay(<%=currentParentBioAssay.getId()%>);
					<%
				}
				else if (currentPhysicalBioAssay != null)
				{
					%>
					extracts = getExtractsFromPhysicalBioAssay(<%=currentPhysicalBioAssay.getId()%>);
					<%
				}
			}
			%>

			var currentExtractId = frm.extract_id[frm.extract_id.selectedIndex].value;
			frm.extract_id.length = 0;
			frm.extract_id[frm.extract_id.length] = new Option('- none -', 0);
			var currentWasFound = 0;
			if (extracts != null)
			{
				for (var i = 0; i < extracts.length; i++)
				{
					var position = extracts[i].position;
					var prefix = position ? position + ': ' : '';
					frm.extract_id[frm.extract_id.length] = new Option(prefix + extracts[i].name, extracts[i].id);
					if (currentExtractId == extracts[i].id) 
					{
						frm.extract_id.selectedIndex = frm.extract_id.length - 1;
						currentWasFound = 1;
					}
				}
			}
			<%
			if (currentExtract != null)
			{
				%>
				if (currentExtractId && !currentWasFound)
				{
					frm.extract_id[frm.extract_id.length] = new Option('<%=HTML.javaScriptEncode(currentExtract.getName())%>', currentExtractId);
					frm.extract_id.selectedIndex = frm.extract_id.length - 1;
				}
				<%
			}
			%>
		}
		
		function getExtractsFromPhysicalBioAssay(physicalBioAssayId)
		{
			if (!physicalBioAssayId) return null;
			var request = Ajax.getXmlHttpRequest();
			var url = '../physicalbioassays/ajax.jsp?ID=<%=ID%>&cmd=GetSources';
			url += '&item_id=' + physicalBioAssayId;
			request.open("GET", url, false); 
			request.send(null);
			
			var response = JSON.parse(request.responseText);
			if (response.status != 'ok')
			{
				alert(response.message);
				return null;
			}
			return response.sources;
		}
	
		function getExtractsFromParentBioassay(bioAssayId)
		{
			if (!bioAssayId) return null;
			var request = Ajax.getXmlHttpRequest();
			var url = 'ajax.jsp?ID=<%=ID%>&cmd=GetExtracts';
			url += '&item_id=' + bioAssayId;
			request.open("GET", url, false); 
			request.send(null);

			var response = JSON.parse(request.responseText);
			if (response.status != 'ok')
			{
				alert(response.message);
				return null;
			}
			return response.sources;
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="bioAssay" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom" active="<%=tabId%>" remember="<%=tabId == null && bioAssay != null%>" switch="switchTab"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Bioassay" validate="validateBioAssay()" helpid="derivedbioassay.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt" width="120px">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(bioAssay == null ? Values.getString(cc.getPropertyValue("name"), "New derived bioassay") : bioAssay.getName())%>" 
					size="40" maxlength="<%=DerivedBioAssay.MAX_NAME_LENGTH%>"></td>
			</tr>

			<tr valign="top">
				<td class="prompt">Type</td>
				<td colspan="2">
					<select name="subtype_id"
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>
						onchange="subtypeOnChange()"
						>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">-none-
						<%
						int currentSubtypeId = currentSubtype == null ? 0 : currentSubtype.getId();
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							if (id != currentSubtypeId && subtype.isRemoved()) continue;
							%>
							<option value="<%=id == currentSubtypeId && bioAssay != null ? -id : id%>" 
								<%=id == currentSubtypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription()) %>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
			</tr>
			<%
			if (bioAssay == null)
			{
				%>
				<tr>
					<td class="prompt">Parent type</td>
					<td>
						<input id="isRoot" type="radio" name="isRoot" value="1" 
							<%=currentParentBioAssay == null ? "checked" : "" %>
							onchange="isRootOnChange()"><label for="isRoot">Physical bioassay</label>
						<input id="isChild" type="radio" name="isRoot" value="0"
							<%=currentParentBioAssay == null ? "" : "checked" %>
							onchange="isRootOnChange()"><label for="isChild">Derived bioassay</label><br>
					</td>
				</tr>
				<tr id="physicalBioAssaySection" style="display: none;">
					<td class="subprompt">-physical bioassay</td>
					<td>
						<base:select 
							id="physicalbioassay_id"
							clazz="selectionlist unchangeable"
							required="true"
							current="<%=currentPhysicalBioAssay%>"
							recent="<%=recentPhysicalBioAssays%>"
							newitem="true"
							onselect="selectPhysicalBioAssayOnClick()"
							onchange="physicalBioAssayOnChange()"
						/>
					</td>
				</tr>
				<tr id="parentBioAssaySection" style="display: none;">
					<td class="subprompt">-bioassay</td>
					<td>
						<base:select 
							id="parent_id"
							clazz="selectionlist unchangeable"
							required="true"
							current="<%=currentParentBioAssay%>"
							recent="<%=recentParentBioAssays%>"
							newitem="true"
							onselect="selectParentBioAssayOnClick()"
							onchange="parentBioAssayOnChange()"
						/>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<td class="prompt">Extract</td>
				<td>
					<select name="extract_id" class="selectionlist">
					<option value="">- none -
					<%
					if (currentExtract != null)
					{
						%>
						<option value="<%=currentExtract.getId()%>" selected><%=HTML.encodeTags(currentExtract.getName())%>
						<%
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitems="<%=defaultProtocols%>"
						newitem="<%=bioAssay == null%>"
						onselect="selectProtocolOnClick()"
						onchange="protocolOnChange()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Hardware</td>
				<td>
					<base:select 
						id="hardware_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentHardware%>"
						denied="<%=!readCurrentHardware%>"
						recent="<%=recentHardware%>"
						defaultitems="<%=defaultHardware%>"
						newitem="<%=bioAssay == null%>"
						onselect="selectHardwareOnClick()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Software</td>
				<td>
					<base:select 
						id="software_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentSoftware%>"
						denied="<%=!readCurrentSoftware%>"
						recent="<%=recentSoftware%>"
						defaultitems="<%=defaultSoftware%>"
						newitem="<%=bioAssay == null%>"
						onselect="selectSoftwareOnClick()"
					/>
				</td>
			</tr>

			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(bioAssay == null ? cc.getPropertyValue("description") : bioAssay.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'bioAssay', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i>
			<%if (bioAssay == null) {%><br>
				<i><base:icon image="unchangeable.gif" /> = can't be changed later</i>
			<%}%>
			</div>
		</t:tab>

		<t:tab id="datafiles" title="Data files" helpid="datafiles.edit">
			<iframe name="datafiles" id="idDatafiles" src="../../common/datafiles/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>

		<t:tab id="annotations" title="Annotations" 
			helpid="annotations.edit" tooltip="Enter values for annotations">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" helpid="annotations.edit.inherited">
			<iframe name="inheritedAnnotations" id="idInheritedAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
