<%-- $Id: edit_bioassay.jsp 5767 2011-09-28 07:31:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg, Gregory Vincic
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ArraySlide"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ListUtil"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PHYSICALBIOASSAY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	String name = null;
	PhysicalBioAssay pba = null;
	BioMaterialEvent creationEvent = null;
	Date eventDate = null;
	List<Extract> parentExtracts = null;
	
	boolean readCurrentSubtype = true;
	ItemSubtype currentSubtype = null;
	boolean readCurrentArraySlide = true;
	ArraySlide currentArraySlide = null;
	
	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;
	
	boolean readCurrentHardware = true;
	Hardware currentHardware = null;

	if (itemId == 0)
	{
		title = "Create physical bioassay";
		cc.removeObject("item");
		if (cc.getPropertyFilter("creationEvent.protocol.name") != null)
		{
			currentProtocol = Base.getFirstMatching(dc, Protocol.getQuery(), "name", cc.getPropertyFilter("creationEvent.protocol.name"));
		}
		if (cc.getPropertyFilter("creationEvent.hardware.name") != null)
		{
			currentHardware = Base.getFirstMatching(dc, Hardware.getQuery(), "name", cc.getPropertyFilter("creationEvent.hardware.name"));
		}
		if (cc.getPropertyFilter("arraySlide.name") != null)
		{
			currentArraySlide = Base.getFirstMatching(dc, ArraySlide.getQuery(), "name", cc.getPropertyFilter("arraySlide.name"));
		}
		name = Values.getString(cc.getPropertyValue("name"), "New physical bioassay");
		eventDate = (Date)cc.getPropertyObject("creationEvent.eventDate");
		
		int currentSubtypeId = Values.getInt(request.getParameter("subtype_id"));
		List<ItemSubtype> relatedToParent = Collections.emptyList();
		ItemQuery<Extract> extractsQuery = null;
		if (Values.getBoolean(request.getParameter("useParents")))
		{
			ItemContext lc = sc.getCurrentContext(Item.EXTRACT);
			if (lc.getSelected().size() > 0)
			{
				extractsQuery = Extract.getQuery();
				extractsQuery.include(Include.ALL);
				extractsQuery.order(Orders.asc(Hql.property("name")));
				extractsQuery.restrict(Restrictions.in(Hql.property("id"), 
					Expressions.parameter("selected", lc.getSelected(), Type.INT)));
			}
		}
		else if (request.getParameter("extract_id") != null)
		{
			int leId = Values.getInt(request.getParameter("extract_id"));
			extractsQuery = Extract.getQuery();
			extractsQuery.include(Include.ALL);
			extractsQuery.restrict(Restrictions.eq(Hql.property("id"), 
				Expressions.integer(leId)));
		}
		
		if (extractsQuery != null)
		{
			parentExtracts = extractsQuery.list(dc);
			if (currentSubtypeId == 0 && parentExtracts.size() > 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, parentExtracts.get(0), Item.PHYSICALBIOASSAY);
			}
		}
		
		if (currentSubtypeId == 0) 
		{
			if (relatedToParent.size() > 0)
			{
				// Find most recently used related subtype
				List<ItemSubtype> recentSubtypes = (List<ItemSubtype>)cc.getRecent(dc, Item.ITEMSUBTYPE);
				currentSubtype = ListUtil.findFirstCommon(recentSubtypes, relatedToParent, relatedToParent.get(0));
			}
			else
			{
				int recentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0));
				currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), recentSubtypeId);
				if (currentSubtypeId > 0) currentSubtype = ItemSubtype.getById(dc, currentSubtypeId);
			}
		}
	}
	else
	{
		pba = PhysicalBioAssay.getById(dc, itemId);
		pba.checkPermission(Permission.WRITE);
		creationEvent = pba.getCreationEvent();
		eventDate = creationEvent.getEventDate();
		cc.setObject("item", pba);
		title = "Edit physical bioassay -- " + HTML.encodeTags(pba.getName());
		name = pba.getName();
		
		try
		{
			currentSubtype = pba.getItemSubtype();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}

		try
		{
			currentArraySlide = pba.getArraySlide();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentArraySlide = false;
		}
		try
		{
			currentProtocol = creationEvent.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
		try
		{
			currentHardware = creationEvent.getHardware();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentHardware = false;
		}
		
		// Query to retrieve source extracts
		ItemQuery<Extract> extractsQuery = (ItemQuery<Extract>)creationEvent.getSources();
		extractsQuery.include(Include.ALL);
		extractsQuery.order(Orders.asc(Hql.property("name")));
		parentExtracts = extractsQuery.list(dc);
		
	}
	
	// Default items 
	int activeProjectId = sc.getActiveProjectId();
	List<Protocol> defaultProtocols = null;
	List<Hardware> defaultHardware = null;
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		defaultProtocols = (List<Protocol>)activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.PROTOCOL);
		defaultHardware = (List<Hardware>)activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.HARDWARE);
	}
	
	// Load recently used items
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL, currentSubtype);
	List<Hardware> recentHardware = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE, currentSubtype);
	
	// Query to retrieve item types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), pba);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js,linkitems.js,subtypes.js,ajax.js,json2.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Physical bioassay" tab
		function validatePhysicalBioAssay()
		{
			var frm = document.forms['bioassay'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (!Numbers.isInteger(frm.size.value))
			{
				alert("'" + frm.size.value + "' is not a valid number");
				frm.size.focus();
				return false;
			}
			else if (parseInt(frm.size.value) <= 0)
			{
				alert("Size must be > 0");
				frm.size.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['bioassay'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				frm.modifiedExtracts.value = Link.exportModified(frm, 'E', true).join(',');
				frm.removedExtracts.value = Link.getActionIds(-1, 'E').join(',');
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		var protocolChanged = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && (protocolChanged || !annotationsLoaded))
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=pba == null ? 0 : pba.getId()%>, getProtocolId());
					annotationsLoaded = true;
					protocolChanged = false;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
			}
		}
		
		function getProtocolId()
		{
			var frm = document.forms['bioassay'];
			var protocolId = 0;
			if (frm.protocol_id.length > 0 && !frm.protocol_id.disabled) 
			{
				protocolId = Math.abs(parseInt(frm.protocol_id[frm.protocol_id.selectedIndex].value));				
			}
			return protocolId;
		}
		
		function getParents()
		{
			var frm = document.forms['bioassay'];
			var parents = new Array();

			var arraySlideId = Math.abs(parseInt(frm.arrayslide_id[frm.arrayslide_id.selectedIndex].value));
			if (arraySlideId > 0) parents[parents.length] = 'ARRAYSLIDE:'+arraySlideId;

			var ids = Link.getListIds(frm.extracts, 'L');
			if (ids.length > 0)
			{
				parents[parents.length] = 'EXTRACT:'+ids.join(':');
			}
			return parents;
		}

		function subtypeOnChange()
		{
			var frm = document.forms['bioassay'];
			var subtypeId = ItemSubtype.getSubtypeId('bioassay');
			var recentInfo = ItemSubtype.getRecentAndRelatedInfo(subtypeId, 'BIOASSAY', ['PROTOCOL', 'HARDWARE']);
			
			protocolChanged = ItemSubtype.updateSelectionList(frm.protocol_id, recentInfo.PROTOCOL['recent'], recentInfo.PROTOCOL['default']);
			ItemSubtype.updateSelectionList(frm.hardware_id, recentInfo.HARDWARE['recent'], recentInfo.HARDWARE['default']);
		}
		
		function selectProtocolOnClick()
		{
			var frm = document.forms['bioassay'];
			var url = '../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setProtocolCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioassay', 'PROTOCOL');
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectProtocol', 1000, 700);
		}
		function setProtocolCallback(id, name)
		{
			var frm = document.forms['bioassay'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			protocolChanged = true;
		}
		function protocolOnChange()
		{
			protocolChanged = true;
		}
		
		function selectHardwareOnClick()
		{
			var frm = document.forms['bioassay'];
			var url = '../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setHardwareCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioassay', 'HARDWARE');
			if (frm.hardware_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.hardware_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectHardware', 1000, 700);
		}
		function setHardwareCallback(id, name)
		{
			var frm = document.forms['bioassay'];
			var list = frm.hardware_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		
		function arraySlideOnChange()
		{
			var frm = document.forms['bioassay'];
			var selectedIndex = frm.arrayslide_id.selectedIndex
			var arraySlideId = frm.arrayslide_id[selectedIndex].value;
			if (arraySlideId > 0) updateSize(arraySlideId);
			parentsChanged = true;
		}
		function selectArraySlideOnClick()
		{
			var frm = document.forms['bioassay'];
			var url = '../../lims/arrayslides/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setArraySlideCallback';
			if (frm.arrayslide_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.arrayslide_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:STRING:physicalBioAssay.name==';
			url += '&tmpfilter:BOOLEAN:destroyed=false';
			Main.openPopup(url, 'SelectArraySlide', 1000, 700);
		}
		function setArraySlideCallback(arraySlideId, name)
		{
			var frm = document.forms['bioassay'];
			if (frm.arrayslide_id.length < 2) // >
			{
				frm.arrayslide_id[frm.arrayslide_id.length] = new Option();
			}
			frm.arrayslide_id[1].value = arraySlideId;
			frm.arrayslide_id[1].text = name;
			frm.arrayslide_id.selectedIndex = 1;
			updateSize(arraySlideId);
			parentsChanged = true;
		}
		function updateSize(arraySlideId)
		{
			var request = Ajax.getXmlHttpRequest();
			if (request != null)
			{
				var url = '../../lims/arrayslides/ajax.jsp?ID=<%=ID%>&cmd=GetArrayDesign&item_id=' + arraySlideId;
				request.open("GET", url, true);
				Ajax.setReadyStateHandler(request, updateSizeCallback);
				request.send(null);
			}
			return request != null;
		}
		function updateSizeCallback(request)
		{
			var frm = document.forms['bioassay'];
			var response = Ajax.parseJsonResponse(request.responseText);
			if (response.status != 'ok')
			{
				alert(response.message);
				return false;
			}

			if (response.numArrays)
			{
				frm.size.value = response.numArrays;
			}
		}
		
		function addExtractsOnClick()
		{
			var frm = document.forms['bioassay'];
			var ids = Link.getListIds(frm.extracts, 'L');
			var excludes = ids.join(',');
			
			var url = '../../biomaterials/extracts/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple';
			url += '&callback=addExtractCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('bioassay', 'EXTRACT');
			url += '&exclude='+excludes;
			Main.openPopup(url, 'AddExtracts', 1000, 700);
		}
		function addExtractCallback(extractId, name)
		{
			var item = Link.getItem('E', extractId);
			if (!item) item = new Item('E', extractId, '1: '+name+' [-]', '', '');
			Link.addItem(document.forms['bioassay'].extracts, item);
			parentsChanged = true;
			extractsOnChange();
		}
		function extractsOnChange()
		{
			var frm = document.forms['bioassay'];
			var item = frm.extracts[frm.extracts.selectedIndex].item;
			if (item && item.id)
			{
				var i = item.value ? item.value.indexOf(':') : -1;
				frm.used_quantity.value = i >= 0 ? item.value.substring(0, i) : item.value;
				frm.position.value = i >= 0 ? item.value.substring(i+1) : '1';
				frm.used_quantity.focus();
			}
			else
			{
				frm.used_quantity.value = '';
				frm.position.value = '1';
			}
		}
		function usedQuantityOnBlur()
		{
			var frm = document.forms['bioassay'];
			var usedQuantity = frm.used_quantity.value;
			var position = frm.position.value;
			var size = parseInt(frm.size.value);
			if (position != '' && (position > size || position <= 0))
			{
				alert('Position must be between 1 and ' + size);
				return;
			}
			if (position == '') position = 1;
			var displayQuantity = usedQuantity == '' ? '-' : usedQuantity+' µg';
			for (var i = 0; i < frm.extracts.length; i++)	// >
			{
				var option = frm.extracts[i];
				if (option.selected && option.item.id)
				{
					option.item.value = usedQuantity + ':' + position;
					var text = option.text.replace(/\[.*\]/, '['+displayQuantity+']');
					text = text.replace(/\d*\:/, position + ':');
					option.text = text; 
				}
			}
		}
		function positionOnBlur()
		{
			usedQuantityOnBlur();
		}

		function removeOnClick()
		{
			Link.removeSelected(document.forms['bioassay'].extracts);
			parentsChanged = true;
		}

		
		function init()
		{
			var frm = document.forms['bioassay'];
			var extracts = frm.extracts;
			<%
			if (pba == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			if (parentExtracts != null)
			{
				for (Extract extract : parentExtracts)
				{
					if (pba == null)
					{
						%>
						Link.addItem(extracts, new Item('E', <%=extract.getId()%>, '1: <%=HTML.javaScriptEncode(extract.getName())%> [-]', ':1'));
						<%
					}
					else
					{
						BioMaterialEventSource evtSrc = creationEvent.getEventSource(extract);
						Float used = evtSrc.getUsedQuantity();
						String usedQuantity = Values.formatNumber(used, -1);
						String usedWithUnit = used == null ? "-" : usedQuantity + " µg";
						int position = evtSrc.getPosition();
						%>
						Link.addNewItem(extracts, new Item('E', <%=extract.getId()%>, '<%=position + ": " + HTML.javaScriptEncode(extract.getName())%> [<%=usedWithUnit%>]', '<%=usedQuantity%>:<%=position%>'));
						<%
					}
				}
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="bioassay" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom"  remember="<%=pba != null%>" switch="switchTab"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Physical bioassay" validate="validatePhysicalBioAssay()" helpid="physicalbioassay.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=name%>" 
					size="40" maxlength="<%=PhysicalBioAssay.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Type</td>
				<td colspan="2">
					<select name="subtype_id"
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>
						onchange="subtypeOnChange()"
						>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						int currentSubtypeId = currentSubtype == null ? 0 : currentSubtype.getId();
						%>
						<option value="0">-none-
						<%
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							if (id != currentSubtypeId && subtype.isRemoved()) continue;
							%>
							<option value="<%=id == currentSubtypeId && pba != null ? -id : id%>" 
								<%=id == currentSubtypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription()) %>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">Size</td>
				<td><input <%=requiredClazz%> type="text" name="size" 
					value="<%=pba == null ? Values.getString(cc.getPropertyValue("size"), "1") : pba.getSize()%>" 
					size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)"></td>
			</tr>
			<tr>
				<td class="prompt">Created</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<input <%=clazz%> type="text" name="event_date" 
							value="<%=HTML.encodeTags(dateFormatter.format(eventDate))%>" 
							size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
						&nbsp;
					</td>
					<td>
					<base:button 
						onclick="<%="Dates.selectDate('Created', 'bioassay', 'event_date', null, '"+jsDateFormat+"')"%>"
						image="calendar.png"
						title="Calendar&hellip;" 
						tooltip="Select a date from a calendar" 
					/>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="prompt">Registered</td>
				<td><%=dateFormatter.format(creationEvent == null ? new Date() : creationEvent.getEntryDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitems="<%=defaultProtocols%>"
						newitem="<%=pba == null%>"
						onselect="selectProtocolOnClick()"
						onchange="protocolOnChange()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Hardware</td>
				<td>
					<base:select 
						id="hardware_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentHardware%>"
						denied="<%=!readCurrentHardware%>"
						recent="<%=recentHardware%>"
						defaultitems="<%=defaultHardware%>"
						newitem="<%=pba == null%>"
						onselect="selectHardwareOnClick()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Array slide</td>
				<td>
					<base:select 
						id="arrayslide_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentArraySlide%>"
						denied="<%=!readCurrentArraySlide%>"
						newitem="<%=pba == null%>"
						onselect="selectArraySlideOnClick()"
						onchange="arraySlideOnChange()"
					/>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(pba == null ? cc.getPropertyValue("description") : pba.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'bioassay', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="extracts" title="Extracts" helpid="physicalbioassay.extracts">
			<input type="hidden" name="modifiedExtracts" value="">
			<input type="hidden" name="removedExtracts" value="">
		
			<table class="form" cellspacing=0>
			<tr valign="top">
				<td class="prompt">Extracts</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr valign="top">
					<td>
						<select name="extracts" size="15" multiple style="width: 20em;" 
							onchange="extractsOnChange()">
						</select>&nbsp;<br>
					</td>
					<td>
						<table border="0">
						<tr><td width="150"><base:button 
							clazz="leftaligned buttonclass"
							onclick="addExtractsOnClick()" 
							title="Add&nbsp;extracts&hellip;" 
							tooltip="Add extracts"
							/></td></tr>
						<tr><td width="150"><base:button 
							clazz="leftaligned buttonclass"
							onclick="removeOnClick()" 
							title="Remove" 
							tooltip="Remove the selected extracts"
						/></td></tr>
						</table>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			
			<tr>
				<td style="text-align: right; padding-right: 5px;">- used quantity</td>
				<td>
						<input <%=clazz%> type="text" name="used_quantity" value=""
							size="12" maxlength="10" onkeypress="return Numbers.numberOnly(event)"
							onkeyup="usedQuantityOnBlur()"
						> (µg)
				</td>
			</tr>

			<tr>
				<td style="text-align: right; padding-right: 5px;">- position</td>
				<td>
						<input <%=clazz%> type="text" name="position" value=""
							size="12" maxlength="10" onkeypress="return Numbers.numberOnly(event)"
							onkeyup="positionOnBlur()"
						> (1 -- size of bioassay)
				</td>
			</tr>

			</table>
		</t:tab>

		<t:tab id="annotations" title="Annotations &amp; parameters" 
			helpid="annotations.edit" tooltip="Enter values for annotations and protocol parameters">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" helpid="annotations.edit.inherited">
		
			<iframe name="inheritedAnnotations" id="idInheritedAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
