<%-- $Id: view_rawdata.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.RawDataProperty"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.ReporterType"
	import="net.sf.basedb.core.Reporter"
	import="net.sf.basedb.core.Feature"
	import="net.sf.basedb.core.Well"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.ArrayDesignBlock"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.data.RawData"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.data.FeatureData"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
	private static final Item itemType = Item.RAWDATA;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final int rawBioAssayId = Values.getInt(request.getParameter("rawbioassay_id"));
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	final RawBioAssay rawBioAssay = RawBioAssay.getById(dc, rawBioAssayId);
	final RawDataType rawDataType = rawBioAssay.getRawDataType();
	final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, rawDataType.getId(), null, null);
	final int itemId = cc.getId();
	final boolean hasSpotImages = rawBioAssay.hasSpotImages();	
	
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	final RawData rawData = rawBioAssay.getRawDataById(itemId, true);
	String title = "Raw data of "+HTML.encodeTags(rawBioAssay.getName()) + " at position " + rawData.getPosition();
	
	final ReporterData reporter = rawData.getReporter();
	final FeatureData feature = rawData.getFeature();
	Formatter<Date> dateFormatter = FormatterFactory.getDateTimeFormatter(sc);
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);
	%>
	<base:page title="<%=title%>" type="popup">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 540, 460);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<h3 class="docked"><%=title%></h3>
	
		<t:tabcontrol id="rawdata" contentstyle="<%="height: "+(int)(scale*340)+"px;"%>" position="bottom">
		<t:tab id="raw" title="Raw data">
		
			<table border="0" cellspacing="0" cellpadding="0">
			<tr valign="top">
			<td>
				<table class="form" cellspacing=0>
				<tr>
					<td class="prompt">Position</td>
					<td><%=rawData.getPosition()%></td>
				</tr>
				<tr>
					<td class="prompt">Block</td>
					<td><%=rawData.getBlock()%></td>
				</tr>
				<tr>
					<td class="prompt">Row</td>
					<td><%=rawData.getRow()%></td>
				</tr>
				<tr>
					<td class="prompt">Column</td>
					<td><%=rawData.getColumn()%></td>
				</tr>
				<tr>
					<td class="prompt">Meta grid X</td>
					<td><%=rawData.getMetaGridX()%></td>
				</tr>
				<tr>
					<td class="prompt">Meta grid Y</td>
					<td><%=rawData.getMetaGridY()%></td>
				</tr>
				<tr>
					<td class="prompt">X</td>
					<td><%=rawData.getX()%></td>
				</tr>
				<tr>
					<td class="prompt">Y</td>
					<td><%=rawData.getY()%></td>
				</tr>
				<%
				if (reporter == null)
				{
					%>
					<tr>
						<td class="prompt">Reporter</td>
						<td><i>- none -</i></td>
					</tr>
					<%
				}
				%>
				<%
				if (feature == null)
				{
					%>
					<tr>
						<td class="prompt">Feature / well</td>
						<td><i>- none -</i></td>
					</tr>
					<%
				}
				%>
				<tr valign="top">
					<td class="prompt">Spot image</td>
					<td>
						<%
						if (hasSpotImages)
						{
							%>
							<img class="spotimage" src="spotimage/<%=ID%>/<%=rawBioAssay.getId()%>/<%=itemId%>/spot<%=rawData.getPosition()%>.png">
							<%
						}
						else
						{
							%>
							<i>- none -</i>
							<%
						}
						%>
					</td>
				</tr>
				</table>
			</td>
			<td>&nbsp;&nbsp;</td>
			<td>
				<table class="form" cellspacing=0>
					<%
					boolean needsTr = true;
					for (RawDataProperty rawProperty : rawDataType.getProperties())
					{
						String name = rawProperty.getName();
						Formatter f = FormatterFactory.getExtendedPropertyFormatter(sc, rawProperty);
						String value = f.format(rawData.getExtended(name));
						title = Values.trimString(rawProperty.getTitle(), 25);
						%>
							<%=needsTr ? "<tr valign=\"top\">" : "" %>
							<td class="prompt"><span 
								title="<%=HTML.encodeTags(rawProperty.getDescription())%>"><%=HTML.encodeTags(title)%></span>
							</td>
							<td><%=value%></td>
							<td>&nbsp;&nbsp;</td>
							<%=needsTr ? "" : "</tr>"%>
						<%
						needsTr = !needsTr;
					}
					%>
					<%=needsTr ? "" : "</tr>"%>
				</table>

			</td>
			</tr>
			</table>
			
		</t:tab>
		
		<%
		if (reporter != null)
		{
			boolean readCurrentReporterType = true;
			ReporterType currentReporterType = null;
			try
			{
				currentReporterType = Reporter.getReporterType(dc, reporter);
			}
			catch (PermissionDeniedException ex)
			{
				readCurrentReporterType = false;
			}
			%>
			<t:tab id="reporter" title="Reporter" >
				<table border="0" cellspacing="0" cellpadding="0">
				<tr valign="top">
				<td>
					<table class="form" cellspacing=0>
					<tr>
						<td class="prompt">Name</td>
						<td><%=HTML.encodeTags(reporter.getName())%></td>
					</tr>
					<tr>
						<td class="prompt">External ID</td>
						<td><%=HTML.encodeTags(reporter.getExternalId())%></td>
					</tr>
					<tr>
						<td class="prompt">Type</td>
						<td><%=Base.getEncodedName(currentReporterType, !readCurrentReporterType)%></td>
					</tr>
					<tr>
						<td class="prompt">Gene symbol</td>
						<td><%=HTML.encodeTags(reporter.getSymbol())%></td>
					</tr>
					<tr valign="top">
						<td class="prompt">Description</td>
						<td><%=HTML.niceFormat(reporter.getDescription())%></td>
					</tr>
					<tr>
						<td class="prompt">Last update</td>
						<td><%=dateFormatter.format(reporter.getLastUpdate())%></td>
					</tr>
					</table>
				</td>
				<td>&nbsp;&nbsp;</td>
				<td>
					<table class="form" cellspacing=0>
						<%
						List<ExtendedProperty> reporterProperties = ExtendedProperties.getProperties("ReporterData");
						if (reporterProperties != null)
						{
							boolean needsTr = true;
							for (ExtendedProperty ep : reporterProperties)
							{
								String name = ep.getName();
								Formatter f = FormatterFactory.getExtendedPropertyFormatter(sc, ep);
								String value = f.format(reporter.getExtended(name));
								%>
									<%=needsTr ? "<tr valign=\"top\">" : "" %>
									<td class="prompt"><%=HTML.encodeTags(ep.getTitle())%></td>
									<td><%=value%></td>
									<td>&nbsp;&nbsp;</td>
									<%=needsTr ? "" : "</tr>"%>
								<%
								needsTr = !needsTr;
							}
							%>
							<%=needsTr ? "" : "</tr>"%>
							<%
						}
						%>
					</table>
				</td>
				</tr>
				</table>
			</t:tab>
			<%
		}
		%>

		<%
		if (feature != null)
		{
			ArrayDesignBlock block = null;
			boolean readBlock = true;
			try
			{
				block = Feature.getArrayDesignBlock(dc, feature);
			}
			catch (PermissionDeniedException ex)
			{
				readBlock = false;
			}
			
			Well well = null;
			boolean readWell = true;
			try
			{
				well = Feature.getWell(dc, feature);
			}
			catch (PermissionDeniedException ex)
			{
				readWell = false;
			}
			%>
			<t:tab id="feature" title="Feature / well" >
			<h4>Feature</h4>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Position</td>
				<td><%=feature.getPosition()%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Meta grid X</td>
				<td><%=readBlock ? Integer.toString(block.getMetaGridX()) : "<i>- denied -</i>"%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Meta grid Y</td>
				<td><%=readBlock ? Integer.toString(block.getMetaGridY()) : "<i>- denied -</i>"%></td>
			</tr>
			<tr>
				<td class="prompt">Row</td>
				<td><%=feature.getRow()%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Block size X</td>
				<td><%=readBlock ? Integer.toString(block.getBlockSizeX()) : "<i>- denied -</i>"%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Block size Y</td>
				<td><%=readBlock ? Integer.toString(block.getBlockSizeY()) : "<i>- denied -</i>"%></td>
			</tr>
			<tr>
				<td class="prompt">Column</td>
				<td><%=feature.getColumn()%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Origin X</td>
				<td><%=readBlock ? Integer.toString(block.getOriginX()) : "<i>- denied -</i>"%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Origin Y</td>
				<td><%=readBlock ? Integer.toString(block.getOriginY()) : "<i>- denied -</i>"%></td>
			</tr>
			<tr>
				<td class="prompt">Block number</td>
				<td><%=block.getBlockNumber()%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Spacing X</td>
				<td><%=readBlock ? Integer.toString(block.getSpacingX()) : "<i>- denied -</i>"%></td>
				<td>&nbsp;&nbsp;</td>
				<td class="prompt">Spacing Y</td>
				<td><%=readBlock ? Integer.toString(block.getSpacingY()) : "<i>- denied -</i>"%></td>
			</tr>
			</table>
			
			<h4>Well</h4>
			<%
			if (!readWell)
			{
				%>
				<i>- denied -</i>
				<%
			}
			else if (well == null)
			{
				%>
				<i>- none -</i>
				<%
			}
			else
			{
				Plate plate = well.getPlate();
				%>
				<table class="form" cellspacing=0>
				<tr>
					<td class="prompt">Plate</td>
					<td><%=HTML.encodeTags(plate.getName())%></td>
				</tr>
				<tr>
					<td class="prompt">Row</td>
					<td><%=rowFormatter.format(well.getRow())%></td>
				</tr>
				<tr>
					<td class="prompt">Column</td>
					<td><%=columnFormatter.format(well.getColumn())%></td>
				</tr>
				</table>
				<%
			}
			%>
			</t:tab>
			<%
		}
		%>
		</t:tabcontrol>

		<div align="center">
			<table>
			<tr>
			<td><base:button onclick="window.close()" title="Close" /></td>
			</tr>
			</table>
		</div>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
